/*
This walk does the following:
 
1) creates functionTable is a hastable of linked list of the 
   correct order for variable names (the linked list
  contains strings)
*/
package wig.code;

import wig.*;
import wig.node.*;
import wig.analysis.*;
import wig.symbol.*;
import wig.compiler.*;
import java.util.*;

public class PreCodeWalk extends DepthFirstAdapter
{

    private SymbolTable GlobalTable;
    private Hashtable cstToScopeMap;
    private Hashtable typeTable;
    private AFunction currentFunction;
    private Hashtable codeTable;
    private Hashtable functionTable;

    public PreCodeWalk(AnalysisDataManager manager)
    {
        GlobalTable = manager.getGlobalTable();
        cstToScopeMap = manager.getCstToScopeMap();
        typeTable = manager.getTypeTable();
        codeTable = manager.getCodeTable();
        functionTable = manager.getFunctionTable();
    }

    /* in functions*/
    public void inAFunction(AFunction node)
    {
        /*start the variable order list*/
        currentFunction = node;
        functionTable.put(node, new LinkedList());
    }

    /* make a list of arguments*/
    public void inAArgument(AArgument node)
    {
        LinkedList list = (LinkedList) functionTable.get(currentFunction);
        list.add(node.getIdentifier().getText());
    }
}
