/*
    This manager store all the Hashtable for the analysis in all the walks.
 */
package wig.compiler;

import java.util.*;
import wig.symbol.*;


public class AnalysisDataManager
{

    private SymbolTable globalTable;
    private Hashtable cstToScopeMap;
    private Hashtable typeTable;
    private Hashtable codeTable;
    private Hashtable functionTable;
    private Hashtable callTable;
    private Hashtable ccTable;
    private Hashtable plugTable;
    private Hashtable inputTable;
    private Hashtable variableTable;
    private Hashtable tupleTable;
    private Hashtable pushcallTable;


    public AnalysisDataManager()
    {
        globalTable = new SymbolTable();
        cstToScopeMap = new Hashtable();
        typeTable = new Hashtable();
        codeTable = new Hashtable();
        functionTable = new Hashtable();
        callTable = new Hashtable();
        ccTable = new Hashtable();
        plugTable = new Hashtable();
        inputTable = new Hashtable();
        variableTable = new Hashtable();
        tupleTable = new Hashtable();
        pushcallTable = new Hashtable();
    }

    public Hashtable getPushCallTable()
    {
        return pushcallTable;
    }

    public Hashtable getTupleTable()
    {
        return tupleTable;
    }

    public Hashtable getVariableTable()
    {
        return variableTable;
    }

    public Hashtable getInputTable()
    {
        return inputTable;
    }

    public Hashtable getPlugTable()
    {
        return plugTable;
    }

    public Hashtable getCCTable()
    {
        return ccTable;
    }

    public Hashtable getCstToScopeMap()
    {
        return cstToScopeMap;
    }

    public Hashtable getFunctionTable()
    {
        return functionTable;
    }

    public Hashtable getCallTable()
    {
        return callTable;
    }

    public SymbolTable getGlobalTable()
    {
        return globalTable;
    }

    public Hashtable getTypeTable()
    {
        return typeTable;
    }

    public Hashtable getCodeTable()
    {
        return codeTable;
    }

}
