/* This file was generated by SableCC (http://www.sablecc.org/). */

package wig.lexer;

import java.io.*;
import java.util.*;
import wig.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.INWHATEVER; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 2: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INTAG; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INWHATEVER; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INHOLE; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.INWHATEVER; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.INHOLE; break;
                                case 1: state = State.INTAG; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INTAG; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INWHATEVER; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INWHATEVER; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TEol(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new2(int line, int pos) { return new TService(line, pos); }
    Token new3(int line, int pos) { return new TConst(line, pos); }
    Token new4(int line, int pos) { return new THtml(line, pos); }
    Token new5(int line, int pos) { return new THtmlTagStart(line, pos); }
    Token new6(int line, int pos) { return new THtmlTagEnd(line, pos); }
    Token new7(int line, int pos) { return new TInput(line, pos); }
    Token new8(int line, int pos) { return new TSelect(line, pos); }
    Token new9(int line, int pos) { return new TName(line, pos); }
    Token new10(int line, int pos) { return new TType(line, pos); }
    Token new11(int line, int pos) { return new TSchema(line, pos); }
    Token new12(int line, int pos) { return new TSession(line, pos); }
    Token new13(int line, int pos) { return new TShow(line, pos); }
    Token new14(int line, int pos) { return new TExit(line, pos); }
    Token new15(int line, int pos) { return new TReturn(line, pos); }
    Token new16(int line, int pos) { return new TIf(line, pos); }
    Token new17(int line, int pos) { return new TElse(line, pos); }
    Token new18(int line, int pos) { return new TWhile(line, pos); }
    Token new19(int line, int pos) { return new TPlug(line, pos); }
    Token new20(int line, int pos) { return new TReceive(line, pos); }
    Token new21(int line, int pos) { return new TInt(line, pos); }
    Token new22(int line, int pos) { return new TBool(line, pos); }
    Token new23(int line, int pos) { return new TString(line, pos); }
    Token new24(int line, int pos) { return new TVoid(line, pos); }
    Token new25(int line, int pos) { return new TTuple(line, pos); }
    Token new26(int line, int pos) { return new TTrue(line, pos); }
    Token new27(int line, int pos) { return new TFalse(line, pos); }
    Token new28(int line, int pos) { return new TLBrace(line, pos); }
    Token new29(int line, int pos) { return new TRBrace(line, pos); }
    Token new30(int line, int pos) { return new TAssign(line, pos); }
    Token new31(int line, int pos) { return new TSemicolon(line, pos); }
    Token new32(int line, int pos) { return new TLt(line, pos); }
    Token new33(int line, int pos) { return new TGt(line, pos); }
    Token new34(int line, int pos) { return new TLtSlash(line, pos); }
    Token new35(String text, int line, int pos) { return new TLquote(text, line, pos); }
    Token new36(String text, int line, int pos) { return new TRquote(text, line, pos); }
    Token new37(int line, int pos) { return new TLtBracket(line, pos); }
    Token new38(int line, int pos) { return new TGtBracket(line, pos); }
    Token new39(int line, int pos) { return new TLPar(line, pos); }
    Token new40(int line, int pos) { return new TRPar(line, pos); }
    Token new41(int line, int pos) { return new TLBracket(line, pos); }
    Token new42(int line, int pos) { return new TRBracket(line, pos); }
    Token new43(int line, int pos) { return new TComma(line, pos); }
    Token new44(int line, int pos) { return new TKeep(line, pos); }
    Token new45(int line, int pos) { return new TRemove(line, pos); }
    Token new46(int line, int pos) { return new TJoin(line, pos); }
    Token new47(int line, int pos) { return new TEq(line, pos); }
    Token new48(int line, int pos) { return new TNeq(line, pos); }
    Token new49(int line, int pos) { return new TLteq(line, pos); }
    Token new50(int line, int pos) { return new TGteq(line, pos); }
    Token new51(int line, int pos) { return new TNot(line, pos); }
    Token new52(int line, int pos) { return new TMinus(line, pos); }
    Token new53(int line, int pos) { return new TPlus(line, pos); }
    Token new54(int line, int pos) { return new TMult(line, pos); }
    Token new55(int line, int pos) { return new TDiv(line, pos); }
    Token new56(int line, int pos) { return new TMod(line, pos); }
    Token new57(int line, int pos) { return new TAnd(line, pos); }
    Token new58(int line, int pos) { return new TOr(line, pos); }
    Token new59(int line, int pos) { return new TDot(line, pos); }
    Token new60(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new61(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new62(String text, int line, int pos) { return new TIntconst(text, line, pos); }
    Token new63(String text, int line, int pos) { return new TTagintconst(text, line, pos); }
    Token new64(String text, int line, int pos) { return new TPercentconst(text, line, pos); }
    Token new65(String text, int line, int pos) { return new TStringconst(text, line, pos); }
    Token new66(String text, int line, int pos) { return new TTagstringconst(text, line, pos); }
    Token new67(String text, int line, int pos) { return new TMeta(text, line, pos); }
    Token new68(String text, int line, int pos) { return new TWhatever(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {37, 37, 7}, {38, 38, 8}, {40, 40, 9}, {41, 41, 10}, {42, 42, 11}, {43, 43, 12}, {44, 44, 13}, {45, 45, 14}, {46, 46, 15}, {47, 47, 16}, {48, 48, 17}, {49, 57, 18}, {59, 59, 19}, {60, 60, 20}, {61, 61, 21}, {62, 62, 22}, {65, 90, 23}, {91, 91, 24}, {92, 92, 25}, {93, 93, 26}, {95, 95, 27}, {97, 97, 28}, {98, 98, 29}, {99, 99, 30}, {100, 100, 28}, {101, 101, 31}, {102, 102, 32}, {103, 103, 28}, {104, 104, 33}, {105, 105, 34}, {106, 111, 28}, {112, 112, 35}, {113, 113, 28}, {114, 114, 36}, {115, 115, 37}, {116, 116, 38}, {117, 117, 28}, {118, 118, 39}, {119, 119, 40}, {120, 122, 28}, {123, 123, 41}, {124, 124, 42}, {125, 125, 43}, },
            {},
            {},
            {{10, 10, 44}, },
            {},
            {{61, 61, 45}, },
            {{0, 33, 46}, {34, 34, 47}, {35, 91, 46}, {92, 92, 48}, {93, 65535, 46}, },
            {},
            {{38, 38, 49}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 50}, {47, 47, 51}, },
            {},
            {{48, 57, 52}, },
            {},
            {{60, 60, 53}, {61, 61, 54}, {104, 104, 55}, },
            {{61, 61, 56}, },
            {{61, 61, 57}, },
            {{48, 57, 58}, {65, 90, 59}, {95, 95, 60}, {97, 122, 61}, },
            {},
            {{43, 43, 62}, {45, 45, 63}, },
            {},
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 95, -25}, {97, 110, 61}, {111, 111, 64}, {112, 122, 61}, },
            {{48, 110, -31}, {111, 111, 65}, {112, 122, 61}, },
            {{48, 95, -25}, {97, 107, 61}, {108, 108, 66}, {109, 119, 61}, {120, 120, 67}, {121, 122, 61}, },
            {{48, 95, -25}, {97, 97, 68}, {98, 122, 61}, },
            {{48, 95, -25}, {97, 115, 61}, {116, 116, 69}, {117, 122, 61}, },
            {{48, 95, -25}, {97, 101, 61}, {102, 102, 70}, {103, 109, 61}, {110, 110, 71}, {111, 122, 61}, },
            {{48, 107, -33}, {108, 108, 72}, {109, 122, 61}, },
            {{48, 95, -25}, {97, 100, 61}, {101, 101, 73}, {102, 122, 61}, },
            {{48, 95, -25}, {97, 98, 61}, {99, 99, 74}, {100, 100, 61}, {101, 101, 75}, {102, 103, 61}, {104, 104, 76}, {105, 115, 61}, {116, 116, 77}, {117, 122, 61}, },
            {{48, 95, -25}, {97, 113, 61}, {114, 114, 78}, {115, 116, 61}, {117, 117, 79}, {118, 122, 61}, },
            {{48, 110, -31}, {111, 111, 80}, {112, 122, 61}, },
            {{48, 95, -25}, {97, 103, 61}, {104, 104, 81}, {105, 122, 61}, },
            {},
            {{124, 124, 82}, },
            {},
            {},
            {},
            {{0, 65535, -8}, },
            {},
            {{0, 33, 46}, {34, 34, 83}, {35, 65535, -8}, },
            {},
            {{0, 41, 84}, {42, 42, 85}, {43, 65535, 84}, },
            {{0, 9, 86}, {10, 10, 87}, {11, 12, 86}, {13, 13, 88}, {14, 65535, 86}, },
            {{48, 57, 52}, },
            {},
            {},
            {{116, 116, 89}, },
            {},
            {},
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {},
            {},
            {{48, 110, -31}, {111, 111, 90}, {112, 122, 61}, },
            {{48, 95, -25}, {97, 109, 61}, {110, 110, 91}, {111, 122, 61}, },
            {{48, 95, -25}, {97, 114, 61}, {115, 115, 92}, {116, 122, 61}, },
            {{48, 95, -25}, {97, 104, 61}, {105, 105, 93}, {106, 122, 61}, },
            {{48, 107, -33}, {108, 108, 94}, {109, 122, 61}, },
            {{48, 95, -25}, {97, 108, 61}, {109, 109, 95}, {110, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 115, -35}, {116, 116, 96}, {117, 122, 61}, },
            {{48, 95, -25}, {97, 116, 61}, {117, 117, 97}, {118, 122, 61}, },
            {{48, 98, -39}, {99, 99, 98}, {100, 115, 61}, {116, 116, 99}, {117, 122, 61}, },
            {{48, 103, -42}, {104, 104, 100}, {105, 122, 61}, },
            {{48, 113, -40}, {114, 114, 101}, {115, 115, 102}, {116, 122, 61}, },
            {{48, 110, -31}, {111, 111, 103}, {112, 122, 61}, },
            {{48, 113, -40}, {114, 114, 104}, {115, 122, 61}, },
            {{48, 116, -74}, {117, 117, 105}, {118, 122, 61}, },
            {{48, 95, -25}, {97, 111, 61}, {112, 112, 106}, {113, 122, 61}, },
            {{48, 104, -69}, {105, 105, 107}, {106, 122, 61}, },
            {{48, 104, -69}, {105, 105, 108}, {106, 122, 61}, },
            {},
            {{0, 65535, -8}, },
            {{0, 65535, -52}, },
            {{0, 41, 109}, {42, 42, 85}, {43, 46, 109}, {47, 47, 110}, {48, 65535, 109}, },
            {{0, 65535, -53}, },
            {},
            {{10, 10, 111}, },
            {{109, 109, 112}, },
            {{48, 107, -33}, {108, 108, 113}, {109, 122, 61}, },
            {{48, 114, -68}, {115, 115, 114}, {116, 122, 61}, },
            {{48, 100, -38}, {101, 101, 115}, {102, 122, 61}, },
            {{48, 115, -35}, {116, 116, 116}, {117, 122, 61}, },
            {{48, 114, -68}, {115, 115, 117}, {116, 122, 61}, },
            {{48, 107, -33}, {108, 108, 118}, {109, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 95, -25}, {97, 102, 61}, {103, 103, 119}, {104, 122, 61}, },
            {{48, 100, -38}, {101, 101, 120}, {102, 122, 61}, },
            {{48, 116, -74}, {117, 117, 121}, {118, 122, 61}, },
            {{48, 100, -38}, {101, 101, 122}, {102, 122, 61}, },
            {{48, 95, -25}, {97, 117, 61}, {118, 118, 123}, {119, 122, 61}, },
            {{48, 114, -68}, {115, 115, 124}, {116, 122, 61}, },
            {{48, 95, -25}, {97, 118, 61}, {119, 119, 125}, {120, 122, 61}, },
            {{48, 104, -69}, {105, 105, 126}, {106, 122, 61}, },
            {{48, 100, -38}, {101, 101, 127}, {102, 122, 61}, },
            {{48, 107, -33}, {108, 108, 128}, {109, 122, 61}, },
            {{48, 95, -25}, {97, 99, 61}, {100, 100, 129}, {101, 122, 61}, },
            {{48, 107, -33}, {108, 108, 130}, {109, 122, 61}, },
            {{0, 41, 131}, {42, 42, 85}, {43, 46, 131}, {47, 47, 132}, {48, 65535, 131}, },
            {},
            {},
            {{108, 108, 133}, },
            {{48, 122, -25}, },
            {{48, 115, -35}, {116, 116, 134}, {117, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 100, -38}, {101, 101, 135}, {102, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 104, -69}, {105, 105, 136}, {106, 122, 61}, },
            {{48, 113, -40}, {114, 114, 137}, {115, 122, 61}, },
            {{48, 108, -71}, {109, 109, 138}, {110, 122, 61}, },
            {{48, 104, -69}, {105, 105, 139}, {106, 122, 61}, },
            {{48, 104, -69}, {105, 105, 140}, {106, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 109, -67}, {110, 110, 141}, {111, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 100, -38}, {101, 101, 142}, {102, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 100, -38}, {101, 101, 143}, {102, 122, 61}, },
            {{0, 65535, -111}, },
            {{0, 41, 132}, {42, 42, 85}, {43, 65535, 132}, },
            {{62, 62, 144}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 117, -103}, {118, 118, 145}, {119, 122, 61}, },
            {{48, 109, -67}, {110, 110, 146}, {111, 122, 61}, },
            {{48, 95, -25}, {97, 97, 147}, {98, 122, 61}, },
            {{48, 98, -39}, {99, 99, 148}, {100, 122, 61}, },
            {{48, 110, -31}, {111, 111, 149}, {112, 122, 61}, },
            {{48, 102, -99}, {103, 103, 150}, {104, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {},
            {{48, 100, -38}, {101, 101, 151}, {102, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 100, -38}, {101, 101, 152}, {102, 122, 61}, },
            {{48, 109, -67}, {110, 110, 153}, {111, 122, 61}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
            {{48, 122, -25}, },
        }
        { // INTAG
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {34, 34, 5}, {45, 45, 6}, {48, 48, 7}, {49, 57, 8}, {60, 60, 9}, {61, 61, 10}, {62, 62, 11}, {65, 90, 12}, {95, 95, 13}, {97, 104, 14}, {105, 105, 15}, {106, 109, 14}, {110, 110, 16}, {111, 114, 14}, {115, 115, 17}, {116, 116, 18}, {117, 122, 14}, },
            {},
            {},
            {{10, 10, 19}, },
            {},
            {{0, 33, 20}, {34, 34, 21}, {35, 65535, 20}, },
            {{49, 57, 22}, },
            {},
            {{37, 37, 23}, {48, 57, 24}, },
            {{47, 47, 25}, },
            {},
            {},
            {{48, 57, 26}, {65, 90, 27}, {95, 95, 28}, {97, 122, 29}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 95, -14}, {97, 109, 29}, {110, 110, 30}, {111, 122, 29}, },
            {{48, 95, -14}, {97, 97, 31}, {98, 122, 29}, },
            {{48, 95, -14}, {97, 100, 29}, {101, 101, 32}, {102, 122, 29}, },
            {{48, 95, -14}, {97, 120, 29}, {121, 121, 33}, {122, 122, 29}, },
            {},
            {{0, 65535, -7}, },
            {},
            {{48, 57, 34}, },
            {},
            {{37, 57, -10}, },
            {{104, 104, 35}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 122, -14}, },
            {{48, 95, -14}, {97, 111, 29}, {112, 112, 36}, {113, 122, 29}, },
            {{48, 95, -14}, {97, 108, 29}, {109, 109, 37}, {110, 122, 29}, },
            {{48, 95, -14}, {97, 107, 29}, {108, 108, 38}, {109, 122, 29}, },
            {{48, 111, -32}, {112, 112, 39}, {113, 122, 29}, },
            {{48, 57, 34}, },
            {{116, 116, 40}, },
            {{48, 95, -14}, {97, 116, 29}, {117, 117, 41}, {118, 122, 29}, },
            {{48, 100, -19}, {101, 101, 42}, {102, 122, 29}, },
            {{48, 100, -19}, {101, 101, 43}, {102, 122, 29}, },
            {{48, 100, -19}, {101, 101, 44}, {102, 122, 29}, },
            {{109, 109, 45}, },
            {{48, 95, -14}, {97, 115, 29}, {116, 116, 46}, {117, 122, 29}, },
            {{48, 122, -14}, },
            {{48, 95, -14}, {97, 98, 29}, {99, 99, 47}, {100, 122, 29}, },
            {{48, 122, -14}, },
            {{108, 108, 48}, },
            {{48, 122, -14}, },
            {{48, 115, -43}, {116, 116, 49}, {117, 122, 29}, },
            {{62, 62, 50}, },
            {{48, 122, -14}, },
            {},
        }
        { // INWHATEVER
            {{0, 59, 1}, {60, 60, 2}, {61, 61, 1}, {63, 65535, 1}, },
            {{0, 59, 1}, {61, 65535, -2}, },
            {{33, 33, 3}, {47, 47, 4}, {91, 91, 5}, },
            {{45, 45, 6}, },
            {{104, 104, 7}, },
            {},
            {{45, 45, 8}, },
            {{116, 116, 9}, },
            {{0, 44, 10}, {45, 45, 11}, {46, 65535, 10}, },
            {{109, 109, 12}, },
            {{0, 65535, -10}, },
            {{0, 44, 13}, {45, 45, 14}, {46, 61, 13}, {62, 62, 15}, {63, 65535, 13}, },
            {{108, 108, 16}, },
            {{0, 65535, -10}, },
            {{0, 61, -13}, {62, 62, 17}, {63, 65535, 13}, },
            {{0, 65535, -10}, },
            {{62, 62, 18}, },
            {},
            {},
        }
        { // INHOLE
            {{65, 90, 1}, {93, 93, 2}, {95, 95, 3}, {97, 122, 4}, },
            {{48, 57, 5}, {65, 90, 6}, {95, 95, 7}, {97, 122, 8}, },
            {{62, 62, 9}, },
            {{48, 122, -3}, },
            {{48, 122, -3}, },
            {{48, 122, -3}, },
            {{48, 122, -3}, },
            {{48, 122, -3}, },
            {{48, 122, -3}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 1, 0, 0, 1, 51, -1, 56, -1, 39, 40, 54, 53, 43, 52, 59, 55, 62, 62, 31, 32, 30, 33, 61, 41, -1, 42, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 28, -1, 29, 0, 48, -1, 65, -1, 57, -1, -1, 62, 46, 49, -1, 47, 50, 61, 61, 61, 61, 44, 45, 61, 61, 61, 61, 61, 61, 16, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 58, 65, -1, -1, -1, 60, 60, -1, 61, 61, 61, 61, 61, 61, 21, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, -1, 60, 60, -1, 22, 61, 17, 14, 61, 4, 19, 61, 61, 61, 61, 61, 13, 61, 26, 61, 24, 61, -1, -1, -1, 3, 27, 61, 61, 61, 61, 61, 61, 25, 18, 5, 61, 15, 11, 61, 61, 23, 20, 2, 12, },
        // INTAG
        {-1, 1, 0, 0, 1, 35, -1, 63, 63, -1, 30, 33, 61, 61, 61, 61, 61, 61, 61, 0, -1, 66, 63, 64, 63, -1, 61, 61, 61, 61, 61, 61, 61, 61, 63, -1, 61, 61, 61, 61, -1, 61, 9, 61, 10, -1, 7, 61, -1, 8, 6, },
        // INWHATEVER
        {-1, 68, 32, -1, 34, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 67, 6, },
        // INHOLE
        {-1, 61, -1, 61, 61, 61, 61, 61, 61, 38, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State INTAG = new State(1);
        public final static State INWHATEVER = new State(2);
        public final static State INHOLE = new State(3);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
