/* This file was generated by SableCC (http://www.sablecc.org/). */

package wig.parser;

import wig.lexer.*;
import wig.node.*;
import wig.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(38), node, false); } break;
                    case 2: { Node node = new2(); push(goTo(38), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(39), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(39), node, false); } break;
                    case 5: { Node node = new5(); push(goTo(0), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(40), node, false); } break;
                    case 7: { Node node = new7(); push(goTo(40), node, false); } break;
                    case 8: { Node node = new8(); push(goTo(0), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(41), node, false); } break;
                    case 10: { Node node = new10(); push(goTo(41), node, false); } break;
                    case 11: { Node node = new11(); push(goTo(0), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(0), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(42), node, false); } break;
                    case 14: { Node node = new14(); push(goTo(42), node, false); } break;
                    case 15: { Node node = new15(); push(goTo(0), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(0), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(0), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(1), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(1), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(43), node, false); } break;
                    case 21: { Node node = new21(); push(goTo(43), node, false); } break;
                    case 22: { Node node = new22(); push(goTo(2), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(2), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(44), node, false); } break;
                    case 25: { Node node = new25(); push(goTo(44), node, false); } break;
                    case 26: { Node node = new26(); push(goTo(2), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(2), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(2), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(2), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(2), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(2), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(2), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(3), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(3), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(3), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(3), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(4), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(4), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(4), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(4), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(5), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(5), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(45), node, false); } break;
                    case 44: { Node node = new44(); push(goTo(45), node, false); } break;
                    case 45: { Node node = new45(); push(goTo(6), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(7), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(8), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(8), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(9), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(9), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(9), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(9), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(10), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(10), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(11), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(11), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(12), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(12), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(13), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(14), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(15), node, true); } break;
                    case 62: { Node node = new62(); push(goTo(15), node, true); } break;
                    case 63: { Node node = new63(); push(goTo(15), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(15), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(15), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(15), node, true); } break;
                    case 67: { Node node = new67(); push(goTo(15), node, true); } break;
                    case 68: { Node node = new68(); push(goTo(15), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(15), node, true); } break;
                    case 70: { Node node = new70(); push(goTo(15), node, true); } break;
                    case 71: { Node node = new71(); push(goTo(15), node, true); } break;
                    case 72: { Node node = new72(); push(goTo(16), node, true); } break;
                    case 73: { Node node = new73(); push(goTo(16), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(16), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(16), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(16), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(16), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(16), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(16), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(16), node, true); } break;
                    case 81: { Node node = new81(); push(goTo(16), node, true); } break;
                    case 82: { Node node = new82(); push(goTo(17), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(17), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(18), node, true); } break;
                    case 85: { Node node = new85(); push(goTo(19), node, true); } break;
                    case 86: { Node node = new86(); push(goTo(19), node, true); } break;
                    case 87: { Node node = new87(); push(goTo(19), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(46), node, false); } break;
                    case 89: { Node node = new89(); push(goTo(46), node, false); } break;
                    case 90: { Node node = new90(); push(goTo(19), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(20), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(20), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(21), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(22), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(22), node, true); } break;
                    case 96: { Node node = new96(); push(goTo(23), node, true); } break;
                    case 97: { Node node = new97(); push(goTo(24), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(24), node, true); } break;
                    case 99: { Node node = new99(); push(goTo(25), node, true); } break;
                    case 100: { Node node = new100(); push(goTo(25), node, true); } break;
                    case 101: { Node node = new101(); push(goTo(26), node, true); } break;
                    case 102: { Node node = new102(); push(goTo(26), node, true); } break;
                    case 103: { Node node = new103(); push(goTo(27), node, true); } break;
                    case 104: { Node node = new104(); push(goTo(27), node, true); } break;
                    case 105: { Node node = new105(); push(goTo(27), node, true); } break;
                    case 106: { Node node = new106(); push(goTo(27), node, true); } break;
                    case 107: { Node node = new107(); push(goTo(27), node, true); } break;
                    case 108: { Node node = new108(); push(goTo(27), node, true); } break;
                    case 109: { Node node = new109(); push(goTo(27), node, true); } break;
                    case 110: { Node node = new110(); push(goTo(28), node, true); } break;
                    case 111: { Node node = new111(); push(goTo(28), node, true); } break;
                    case 112: { Node node = new112(); push(goTo(28), node, true); } break;
                    case 113: { Node node = new113(); push(goTo(29), node, true); } break;
                    case 114: { Node node = new114(); push(goTo(29), node, true); } break;
                    case 115: { Node node = new115(); push(goTo(29), node, true); } break;
                    case 116: { Node node = new116(); push(goTo(29), node, true); } break;
                    case 117: { Node node = new117(); push(goTo(30), node, true); } break;
                    case 118: { Node node = new118(); push(goTo(30), node, true); } break;
                    case 119: { Node node = new119(); push(goTo(31), node, true); } break;
                    case 120: { Node node = new120(); push(goTo(31), node, true); } break;
                    case 121: { Node node = new121(); push(goTo(31), node, true); } break;
                    case 122: { Node node = new122(); push(goTo(31), node, true); } break;
                    case 123: { Node node = new123(); push(goTo(31), node, true); } break;
                    case 124: { Node node = new124(); push(goTo(32), node, true); } break;
                    case 125: { Node node = new125(); push(goTo(32), node, true); } break;
                    case 126: { Node node = new126(); push(goTo(32), node, true); } break;
                    case 127: { Node node = new127(); push(goTo(33), node, true); } break;
                    case 128: { Node node = new128(); push(goTo(33), node, true); } break;
                    case 129: { Node node = new129(); push(goTo(33), node, true); } break;
                    case 130: { Node node = new130(); push(goTo(33), node, true); } break;
                    case 131: { Node node = new131(); push(goTo(33), node, true); } break;
                    case 132: { Node node = new132(); push(goTo(33), node, true); } break;
                    case 133: { Node node = new133(); push(goTo(33), node, true); } break;
                    case 134: { Node node = new134(); push(goTo(33), node, true); } break;
                    case 135: { Node node = new135(); push(goTo(33), node, true); } break;
                    case 136: { Node node = new136(); push(goTo(33), node, true); } break;
                    case 137: { Node node = new137(); push(goTo(34), node, true); } break;
                    case 138: { Node node = new138(); push(goTo(34), node, true); } break;
                    case 139: { Node node = new139(); push(goTo(35), node, true); } break;
                    case 140: { Node node = new140(); push(goTo(35), node, true); } break;
                    case 141: { Node node = new141(); push(goTo(36), node, true); } break;
                    case 142: { Node node = new142(); push(goTo(36), node, true); } break;
                    case 143: { Node node = new143(); push(goTo(37), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PService node1 = (PService) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = null;
        XPVariable node5 = null;
        XPSchema node4 = null;
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new1()
    {
        PHtml node2 = (PHtml) pop();
        XPHtml node1 = (XPHtml) pop();
        X1PHtml node = new X1PHtml(node1, node2);
        return node;
    }

    Node new2()
    {
        PHtml node1 = (PHtml) pop();
        X2PHtml node = new X2PHtml(node1);
        return node;
    }

    Node new3()
    {
        PSession node2 = (PSession) pop();
        XPSession node1 = (XPSession) pop();
        X1PSession node = new X1PSession(node1, node2);
        return node;
    }

    Node new4()
    {
        PSession node1 = (PSession) pop();
        X2PSession node = new X2PSession(node1);
        return node;
    }

    Node new5()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = null;
        XPVariable node5 = null;
        XPSchema node4 = (XPSchema) pop();
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new6()
    {
        PSchema node2 = (PSchema) pop();
        XPSchema node1 = (XPSchema) pop();
        X1PSchema node = new X1PSchema(node1, node2);
        return node;
    }

    Node new7()
    {
        PSchema node1 = (PSchema) pop();
        X2PSchema node = new X2PSchema(node1);
        return node;
    }

    Node new8()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = null;
        XPVariable node5 = (XPVariable) pop();
        XPSchema node4 = null;
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new9()
    {
        PVariable node2 = (PVariable) pop();
        XPVariable node1 = (XPVariable) pop();
        X1PVariable node = new X1PVariable(node1, node2);
        return node;
    }

    Node new10()
    {
        PVariable node1 = (PVariable) pop();
        X2PVariable node = new X2PVariable(node1);
        return node;
    }

    Node new11()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = null;
        XPVariable node5 = (XPVariable) pop();
        XPSchema node4 = (XPSchema) pop();
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new12()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = (XPFunction) pop();
        XPVariable node5 = null;
        XPSchema node4 = null;
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new13()
    {
        PFunction node2 = (PFunction) pop();
        XPFunction node1 = (XPFunction) pop();
        X1PFunction node = new X1PFunction(node1, node2);
        return node;
    }

    Node new14()
    {
        PFunction node1 = (PFunction) pop();
        X2PFunction node = new X2PFunction(node1);
        return node;
    }

    Node new15()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = (XPFunction) pop();
        XPVariable node5 = null;
        XPSchema node4 = (XPSchema) pop();
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new16()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = (XPFunction) pop();
        XPVariable node5 = (XPVariable) pop();
        XPSchema node4 = null;
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new17()
    {
        TRBrace node8 = (TRBrace) pop();
        XPSession node7 = (XPSession) pop();
        XPFunction node6 = (XPFunction) pop();
        XPVariable node5 = (XPVariable) pop();
        XPSchema node4 = (XPSchema) pop();
        XPHtml node3 = (XPHtml) pop();
        TLBrace node2 = (TLBrace) pop();
        TService node1 = (TService) pop();
        AService node = new AService(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new18()
    {
        TSemicolon node8 = (TSemicolon) pop();
        THtmlTagEnd node7 = (THtmlTagEnd) pop();
        XPHtmlbody node6 = null;
        THtmlTagStart node5 = (THtmlTagStart) pop();
        TAssign node4 = (TAssign) pop();
        TIdentifier node3 = (TIdentifier) pop();
        THtml node2 = (THtml) pop();
        TConst node1 = (TConst) pop();
        AHtml node = new AHtml(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new19()
    {
        TSemicolon node8 = (TSemicolon) pop();
        THtmlTagEnd node7 = (THtmlTagEnd) pop();
        XPHtmlbody node6 = (XPHtmlbody) pop();
        THtmlTagStart node5 = (THtmlTagStart) pop();
        TAssign node4 = (TAssign) pop();
        TIdentifier node3 = (TIdentifier) pop();
        THtml node2 = (THtml) pop();
        TConst node1 = (TConst) pop();
        AHtml node = new AHtml(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new20()
    {
        PHtmlbody node2 = (PHtmlbody) pop();
        XPHtmlbody node1 = (XPHtmlbody) pop();
        X1PHtmlbody node = new X1PHtmlbody(node1, node2);
        return node;
    }

    Node new21()
    {
        PHtmlbody node1 = (PHtmlbody) pop();
        X2PHtmlbody node = new X2PHtmlbody(node1);
        return node;
    }

    Node new22()
    {
        TGt node4 = (TGt) pop();
        XPAttribute node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TLt node1 = (TLt) pop();
        ATagStartHtmlbody node = new ATagStartHtmlbody(node1, node2, node3, node4);
        return node;
    }

    Node new23()
    {
        TGt node4 = (TGt) pop();
        XPAttribute node3 = (XPAttribute) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TLt node1 = (TLt) pop();
        ATagStartHtmlbody node = new ATagStartHtmlbody(node1, node2, node3, node4);
        return node;
    }

    Node new24()
    {
        PAttribute node2 = (PAttribute) pop();
        XPAttribute node1 = (XPAttribute) pop();
        X1PAttribute node = new X1PAttribute(node1, node2);
        return node;
    }

    Node new25()
    {
        PAttribute node1 = (PAttribute) pop();
        X2PAttribute node = new X2PAttribute(node1);
        return node;
    }

    Node new26()
    {
        TGt node3 = (TGt) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TLtSlash node1 = (TLtSlash) pop();
        ATagEndHtmlbody node = new ATagEndHtmlbody(node1, node2, node3);
        return node;
    }

    Node new27()
    {
        TGtBracket node3 = (TGtBracket) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TLtBracket node1 = (TLtBracket) pop();
        AHoleHtmlbody node = new AHoleHtmlbody(node1, node2, node3);
        return node;
    }

    Node new28()
    {
        TWhatever node1 = (TWhatever) pop();
        AWhateverHtmlbody node = new AWhateverHtmlbody(node1);
        return node;
    }

    Node new29()
    {
        TMeta node1 = (TMeta) pop();
        AMetaHtmlbody node = new AMetaHtmlbody(node1);
        return node;
    }

    Node new30()
    {
        TGt node4 = (TGt) pop();
        XPAttribute node3 = (XPAttribute) pop();
        TInput node2 = (TInput) pop();
        TLt node1 = (TLt) pop();
        AInputHtmlbody node = new AInputHtmlbody(node1, node2, node3, node4);
        return node;
    }

    Node new31()
    {
        TGt node8 = (TGt) pop();
        TSelect node7 = (TSelect) pop();
        TLtSlash node6 = (TLtSlash) pop();
        XPHtmlbody node5 = null;
        TGt node4 = (TGt) pop();
        XPAttribute node3 = (XPAttribute) pop();
        TSelect node2 = (TSelect) pop();
        TLt node1 = (TLt) pop();
        ASelectHtmlbody node = new ASelectHtmlbody(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new32()
    {
        TGt node8 = (TGt) pop();
        TSelect node7 = (TSelect) pop();
        TLtSlash node6 = (TLtSlash) pop();
        XPHtmlbody node5 = (XPHtmlbody) pop();
        TGt node4 = (TGt) pop();
        XPAttribute node3 = (XPAttribute) pop();
        TSelect node2 = (TSelect) pop();
        TLt node1 = (TLt) pop();
        ASelectHtmlbody node = new ASelectHtmlbody(node1, node2, node3, node4, node5, node6, node7, node8);
        return node;
    }

    Node new33()
    {
        PAttr node1 = (PAttr) pop();
        AAttrAttribute node = new AAttrAttribute(node1);
        return node;
    }

    Node new34()
    {
        PAttr node3 = (PAttr) pop();
        TAssign node2 = (TAssign) pop();
        TName node1 = (TName) pop();
        ANameAttribute node = new ANameAttribute(node1, node2, node3);
        return node;
    }

    Node new35()
    {
        PAttr node3 = (PAttr) pop();
        TAssign node2 = (TAssign) pop();
        TType node1 = (TType) pop();
        ATypeAttribute node = new ATypeAttribute(node1, node2, node3);
        return node;
    }

    Node new36()
    {
        PAttr node3 = (PAttr) pop();
        TAssign node2 = (TAssign) pop();
        PAttr node1 = (PAttr) pop();
        AAssignAttribute node = new AAssignAttribute(node1, node2, node3);
        return node;
    }

    Node new37()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AIdAttr node = new AIdAttr(node1);
        return node;
    }

    Node new38()
    {
        TTagstringconst node1 = (TTagstringconst) pop();
        ATagstrAttr node = new ATagstrAttr(node1);
        return node;
    }

    Node new39()
    {
        TTagintconst node1 = (TTagintconst) pop();
        ATagintAttr node = new ATagintAttr(node1);
        return node;
    }

    Node new40()
    {
        TPercentconst node1 = (TPercentconst) pop();
        APercentAttr node = new APercentAttr(node1);
        return node;
    }

    Node new41()
    {
        TRBrace node5 = (TRBrace) pop();
        XPField node4 = null;
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TSchema node1 = (TSchema) pop();
        ASchema node = new ASchema(node1, node2, node3, node4, node5);
        return node;
    }

    Node new42()
    {
        TRBrace node5 = (TRBrace) pop();
        XPField node4 = (XPField) pop();
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TSchema node1 = (TSchema) pop();
        ASchema node = new ASchema(node1, node2, node3, node4, node5);
        return node;
    }

    Node new43()
    {
        PField node2 = (PField) pop();
        XPField node1 = (XPField) pop();
        X1PField node = new X1PField(node1, node2);
        return node;
    }

    Node new44()
    {
        PField node1 = (PField) pop();
        X2PField node = new X2PField(node1);
        return node;
    }

    Node new45()
    {
        TSemicolon node3 = (TSemicolon) pop();
        TIdentifier node2 = (TIdentifier) pop();
        PSimpletype node1 = (PSimpletype) pop();
        AField node = new AField(node1, node2, node3);
        return node;
    }

    Node new46()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PIdentifiers node2 = (PIdentifiers) pop();
        PType node1 = (PType) pop();
        AVariable node = new AVariable(node1, node2, node3);
        return node;
    }

    Node new47()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AOneIdentifiers node = new AOneIdentifiers(node1);
        return node;
    }

    Node new48()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TComma node2 = (TComma) pop();
        PIdentifiers node1 = (PIdentifiers) pop();
        AManyIdentifiers node = new AManyIdentifiers(node1, node2, node3);
        return node;
    }

    Node new49()
    {
        TInt node1 = (TInt) pop();
        AIntSimpletype node = new AIntSimpletype(node1);
        return node;
    }

    Node new50()
    {
        TBool node1 = (TBool) pop();
        ABoolSimpletype node = new ABoolSimpletype(node1);
        return node;
    }

    Node new51()
    {
        TString node1 = (TString) pop();
        AStringSimpletype node = new AStringSimpletype(node1);
        return node;
    }

    Node new52()
    {
        TVoid node1 = (TVoid) pop();
        AVoidSimpletype node = new AVoidSimpletype(node1);
        return node;
    }

    Node new53()
    {
        PSimpletype node1 = (PSimpletype) pop();
        ASimpleType node = new ASimpleType(node1);
        return node;
    }

    Node new54()
    {
        TIdentifier node2 = (TIdentifier) pop();
        TTuple node1 = (TTuple) pop();
        ATupleType node = new ATupleType(node1, node2);
        return node;
    }

    Node new55()
    {
        PCompoundstm node6 = (PCompoundstm) pop();
        TRPar node5 = (TRPar) pop();
        PArguments node4 = null;
        TLPar node3 = (TLPar) pop();
        TIdentifier node2 = (TIdentifier) pop();
        PType node1 = (PType) pop();
        AFunction node = new AFunction(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new56()
    {
        PCompoundstm node6 = (PCompoundstm) pop();
        TRPar node5 = (TRPar) pop();
        PArguments node4 = (PArguments) pop();
        TLPar node3 = (TLPar) pop();
        TIdentifier node2 = (TIdentifier) pop();
        PType node1 = (PType) pop();
        AFunction node = new AFunction(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new57()
    {
        PArgument node1 = (PArgument) pop();
        AOneArguments node = new AOneArguments(node1);
        return node;
    }

    Node new58()
    {
        PArgument node3 = (PArgument) pop();
        TComma node2 = (TComma) pop();
        PArguments node1 = (PArguments) pop();
        AManyArguments node = new AManyArguments(node1, node2, node3);
        return node;
    }

    Node new59()
    {
        TIdentifier node2 = (TIdentifier) pop();
        PType node1 = (PType) pop();
        AArgument node = new AArgument(node1, node2);
        return node;
    }

    Node new60()
    {
        PCompoundstm node5 = (PCompoundstm) pop();
        TRPar node4 = (TRPar) pop();
        TLPar node3 = (TLPar) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TSession node1 = (TSession) pop();
        ASession node = new ASession(node1, node2, node3, node4, node5);
        return node;
    }

    Node new61()
    {
        TSemicolon node1 = (TSemicolon) pop();
        ANoStm node = new ANoStm(node1);
        return node;
    }

    Node new62()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PReceive node3 = null;
        PDocument node2 = (PDocument) pop();
        TShow node1 = (TShow) pop();
        AShowStm node = new AShowStm(node1, node2, node3, node4);
        return node;
    }

    Node new63()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PReceive node3 = (PReceive) pop();
        PDocument node2 = (PDocument) pop();
        TShow node1 = (TShow) pop();
        AShowStm node = new AShowStm(node1, node2, node3, node4);
        return node;
    }

    Node new64()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PDocument node2 = (PDocument) pop();
        TExit node1 = (TExit) pop();
        AExitStm node = new AExitStm(node1, node2, node3);
        return node;
    }

    Node new65()
    {
        TSemicolon node2 = (TSemicolon) pop();
        TReturn node1 = (TReturn) pop();
        AReturnStm node = new AReturnStm(node1, node2);
        return node;
    }

    Node new66()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PExp node2 = (PExp) pop();
        TReturn node1 = (TReturn) pop();
        ARetexpStm node = new ARetexpStm(node1, node2, node3);
        return node;
    }

    Node new67()
    {
        PStm node5 = (PStm) pop();
        TRPar node4 = (TRPar) pop();
        PExp node3 = (PExp) pop();
        TLPar node2 = (TLPar) pop();
        TIf node1 = (TIf) pop();
        AIfStm node = new AIfStm(node1, node2, node3, node4, node5);
        return node;
    }

    Node new68()
    {
        PStm node7 = (PStm) pop();
        TElse node6 = (TElse) pop();
        PStmNoShortIf node5 = (PStmNoShortIf) pop();
        TRPar node4 = (TRPar) pop();
        PExp node3 = (PExp) pop();
        TLPar node2 = (TLPar) pop();
        TIf node1 = (TIf) pop();
        AIfelseStm node = new AIfelseStm(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new69()
    {
        PStm node5 = (PStm) pop();
        TRPar node4 = (TRPar) pop();
        PExp node3 = (PExp) pop();
        TLPar node2 = (TLPar) pop();
        TWhile node1 = (TWhile) pop();
        AWhileStm node = new AWhileStm(node1, node2, node3, node4, node5);
        return node;
    }

    Node new70()
    {
        PCompoundstm node1 = (PCompoundstm) pop();
        ACompStm node = new ACompStm(node1);
        return node;
    }

    Node new71()
    {
        TSemicolon node2 = (TSemicolon) pop();
        PExp node1 = (PExp) pop();
        AExpStm node = new AExpStm(node1, node2);
        return node;
    }

    Node new72()
    {
        TSemicolon node1 = (TSemicolon) pop();
        ANoStmNoShortIf node = new ANoStmNoShortIf(node1);
        return node;
    }

    Node new73()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PReceive node3 = null;
        PDocument node2 = (PDocument) pop();
        TShow node1 = (TShow) pop();
        AShowStmNoShortIf node = new AShowStmNoShortIf(node1, node2, node3, node4);
        return node;
    }

    Node new74()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PReceive node3 = (PReceive) pop();
        PDocument node2 = (PDocument) pop();
        TShow node1 = (TShow) pop();
        AShowStmNoShortIf node = new AShowStmNoShortIf(node1, node2, node3, node4);
        return node;
    }

    Node new75()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PDocument node2 = (PDocument) pop();
        TExit node1 = (TExit) pop();
        AExitStmNoShortIf node = new AExitStmNoShortIf(node1, node2, node3);
        return node;
    }

    Node new76()
    {
        TSemicolon node2 = (TSemicolon) pop();
        TReturn node1 = (TReturn) pop();
        AReturnStmNoShortIf node = new AReturnStmNoShortIf(node1, node2);
        return node;
    }

    Node new77()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PExp node2 = (PExp) pop();
        TReturn node1 = (TReturn) pop();
        ARetexpStmNoShortIf node = new ARetexpStmNoShortIf(node1, node2, node3);
        return node;
    }

    Node new78()
    {
        PStmNoShortIf node7 = (PStmNoShortIf) pop();
        TElse node6 = (TElse) pop();
        PStmNoShortIf node5 = (PStmNoShortIf) pop();
        TRPar node4 = (TRPar) pop();
        PExp node3 = (PExp) pop();
        TLPar node2 = (TLPar) pop();
        TIf node1 = (TIf) pop();
        AIfelseStmNoShortIf node = new AIfelseStmNoShortIf(node1, node2, node3, node4, node5, node6, node7);
        return node;
    }

    Node new79()
    {
        PStmNoShortIf node5 = (PStmNoShortIf) pop();
        TRPar node4 = (TRPar) pop();
        PExp node3 = (PExp) pop();
        TLPar node2 = (TLPar) pop();
        TWhile node1 = (TWhile) pop();
        AWhileStmNoShortIf node = new AWhileStmNoShortIf(node1, node2, node3, node4, node5);
        return node;
    }

    Node new80()
    {
        PCompoundstm node1 = (PCompoundstm) pop();
        ACompStmNoShortIf node = new ACompStmNoShortIf(node1);
        return node;
    }

    Node new81()
    {
        TSemicolon node2 = (TSemicolon) pop();
        PExp node1 = (PExp) pop();
        AExpStmNoShortIf node = new AExpStmNoShortIf(node1, node2);
        return node;
    }

    Node new82()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AIdDocument node = new AIdDocument(node1);
        return node;
    }

    Node new83()
    {
        TRBracket node5 = (TRBracket) pop();
        PPlugs node4 = (PPlugs) pop();
        TLBracket node3 = (TLBracket) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TPlug node1 = (TPlug) pop();
        APlugDocument node = new APlugDocument(node1, node2, node3, node4, node5);
        return node;
    }

    Node new84()
    {
        TRBracket node4 = (TRBracket) pop();
        PInputs node3 = (PInputs) pop();
        TLBracket node2 = (TLBracket) pop();
        TReceive node1 = (TReceive) pop();
        AReceive node = new AReceive(node1, node2, node3, node4);
        return node;
    }

    Node new85()
    {
        TRBrace node4 = (TRBrace) pop();
        XPStm node3 = null;
        XPVariable node2 = null;
        TLBrace node1 = (TLBrace) pop();
        ACompoundstm node = new ACompoundstm(node1, node2, node3, node4);
        return node;
    }

    Node new86()
    {
        TRBrace node4 = (TRBrace) pop();
        XPStm node3 = null;
        XPVariable node2 = (XPVariable) pop();
        TLBrace node1 = (TLBrace) pop();
        ACompoundstm node = new ACompoundstm(node1, node2, node3, node4);
        return node;
    }

    Node new87()
    {
        TRBrace node4 = (TRBrace) pop();
        XPStm node3 = (XPStm) pop();
        XPVariable node2 = null;
        TLBrace node1 = (TLBrace) pop();
        ACompoundstm node = new ACompoundstm(node1, node2, node3, node4);
        return node;
    }

    Node new88()
    {
        PStm node2 = (PStm) pop();
        XPStm node1 = (XPStm) pop();
        X1PStm node = new X1PStm(node1, node2);
        return node;
    }

    Node new89()
    {
        PStm node1 = (PStm) pop();
        X2PStm node = new X2PStm(node1);
        return node;
    }

    Node new90()
    {
        TRBrace node4 = (TRBrace) pop();
        XPStm node3 = (XPStm) pop();
        XPVariable node2 = (XPVariable) pop();
        TLBrace node1 = (TLBrace) pop();
        ACompoundstm node = new ACompoundstm(node1, node2, node3, node4);
        return node;
    }

    Node new91()
    {
        PPlug node1 = (PPlug) pop();
        AOnePlugs node = new AOnePlugs(node1);
        return node;
    }

    Node new92()
    {
        PPlug node3 = (PPlug) pop();
        TComma node2 = (TComma) pop();
        PPlugs node1 = (PPlugs) pop();
        AManyPlugs node = new AManyPlugs(node1, node2, node3);
        return node;
    }

    Node new93()
    {
        PExp node3 = (PExp) pop();
        TAssign node2 = (TAssign) pop();
        TIdentifier node1 = (TIdentifier) pop();
        APlug node = new APlug(node1, node2, node3);
        return node;
    }

    Node new94()
    {
        PInput node1 = (PInput) pop();
        AOneInputs node = new AOneInputs(node1);
        return node;
    }

    Node new95()
    {
        PInput node3 = (PInput) pop();
        TComma node2 = (TComma) pop();
        PInputs node1 = (PInputs) pop();
        AManyInputs node = new AManyInputs(node1, node2, node3);
        return node;
    }

    Node new96()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TAssign node2 = (TAssign) pop();
        PLvalue node1 = (PLvalue) pop();
        AInput node = new AInput(node1, node2, node3);
        return node;
    }

    Node new97()
    {
        POrExp node3 = (POrExp) pop();
        TAssign node2 = (TAssign) pop();
        PLvalue node1 = (PLvalue) pop();
        AAssignExp node = new AAssignExp(node1, node2, node3);
        return node;
    }

    Node new98()
    {
        POrExp node1 = (POrExp) pop();
        ADefaultExp node = new ADefaultExp(node1);
        return node;
    }

    Node new99()
    {
        PAndExp node3 = (PAndExp) pop();
        TOr node2 = (TOr) pop();
        POrExp node1 = (POrExp) pop();
        AOrOrExp node = new AOrOrExp(node1, node2, node3);
        return node;
    }

    Node new100()
    {
        PAndExp node1 = (PAndExp) pop();
        ADefaultOrExp node = new ADefaultOrExp(node1);
        return node;
    }

    Node new101()
    {
        PCmpExp node3 = (PCmpExp) pop();
        TAnd node2 = (TAnd) pop();
        PAndExp node1 = (PAndExp) pop();
        AAndAndExp node = new AAndAndExp(node1, node2, node3);
        return node;
    }

    Node new102()
    {
        PCmpExp node1 = (PCmpExp) pop();
        ADefaultAndExp node = new ADefaultAndExp(node1);
        return node;
    }

    Node new103()
    {
        PAddExp node3 = (PAddExp) pop();
        TEq node2 = (TEq) pop();
        PAddExp node1 = (PAddExp) pop();
        AEqCmpExp node = new AEqCmpExp(node1, node2, node3);
        return node;
    }

    Node new104()
    {
        PAddExp node3 = (PAddExp) pop();
        TNeq node2 = (TNeq) pop();
        PAddExp node1 = (PAddExp) pop();
        ANeqCmpExp node = new ANeqCmpExp(node1, node2, node3);
        return node;
    }

    Node new105()
    {
        PAddExp node3 = (PAddExp) pop();
        TLt node2 = (TLt) pop();
        PAddExp node1 = (PAddExp) pop();
        ALtCmpExp node = new ALtCmpExp(node1, node2, node3);
        return node;
    }

    Node new106()
    {
        PAddExp node3 = (PAddExp) pop();
        TGt node2 = (TGt) pop();
        PAddExp node1 = (PAddExp) pop();
        AGtCmpExp node = new AGtCmpExp(node1, node2, node3);
        return node;
    }

    Node new107()
    {
        PAddExp node3 = (PAddExp) pop();
        TLteq node2 = (TLteq) pop();
        PAddExp node1 = (PAddExp) pop();
        ALteqCmpExp node = new ALteqCmpExp(node1, node2, node3);
        return node;
    }

    Node new108()
    {
        PAddExp node3 = (PAddExp) pop();
        TGteq node2 = (TGteq) pop();
        PAddExp node1 = (PAddExp) pop();
        AGteqCmpExp node = new AGteqCmpExp(node1, node2, node3);
        return node;
    }

    Node new109()
    {
        PAddExp node1 = (PAddExp) pop();
        ADefaultCmpExp node = new ADefaultCmpExp(node1);
        return node;
    }

    Node new110()
    {
        PMultExp node3 = (PMultExp) pop();
        TPlus node2 = (TPlus) pop();
        PAddExp node1 = (PAddExp) pop();
        APlusAddExp node = new APlusAddExp(node1, node2, node3);
        return node;
    }

    Node new111()
    {
        PMultExp node3 = (PMultExp) pop();
        TMinus node2 = (TMinus) pop();
        PAddExp node1 = (PAddExp) pop();
        AMinusAddExp node = new AMinusAddExp(node1, node2, node3);
        return node;
    }

    Node new112()
    {
        PMultExp node1 = (PMultExp) pop();
        ADefaultAddExp node = new ADefaultAddExp(node1);
        return node;
    }

    Node new113()
    {
        PJoinExp node3 = (PJoinExp) pop();
        TMult node2 = (TMult) pop();
        PMultExp node1 = (PMultExp) pop();
        AMultMultExp node = new AMultMultExp(node1, node2, node3);
        return node;
    }

    Node new114()
    {
        PJoinExp node3 = (PJoinExp) pop();
        TDiv node2 = (TDiv) pop();
        PMultExp node1 = (PMultExp) pop();
        ADivMultExp node = new ADivMultExp(node1, node2, node3);
        return node;
    }

    Node new115()
    {
        PJoinExp node3 = (PJoinExp) pop();
        TMod node2 = (TMod) pop();
        PMultExp node1 = (PMultExp) pop();
        AModMultExp node = new AModMultExp(node1, node2, node3);
        return node;
    }

    Node new116()
    {
        PJoinExp node1 = (PJoinExp) pop();
        ADefaultMultExp node = new ADefaultMultExp(node1);
        return node;
    }

    Node new117()
    {
        PJoinExp node3 = (PJoinExp) pop();
        TJoin node2 = (TJoin) pop();
        PTupleExp node1 = (PTupleExp) pop();
        AJoinJoinExp node = new AJoinJoinExp(node1, node2, node3);
        return node;
    }

    Node new118()
    {
        PTupleExp node1 = (PTupleExp) pop();
        ADefaultJoinExp node = new ADefaultJoinExp(node1);
        return node;
    }

    Node new119()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TKeep node2 = (TKeep) pop();
        PTupleExp node1 = (PTupleExp) pop();
        AKeepTupleExp node = new AKeepTupleExp(node1, node2, node3);
        return node;
    }

    Node new120()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TRemove node2 = (TRemove) pop();
        PTupleExp node1 = (PTupleExp) pop();
        ARemoveTupleExp node = new ARemoveTupleExp(node1, node2, node3);
        return node;
    }

    Node new121()
    {
        TRPar node5 = (TRPar) pop();
        PIdentifiers node4 = (PIdentifiers) pop();
        TLPar node3 = (TLPar) pop();
        TKeep node2 = (TKeep) pop();
        PTupleExp node1 = (PTupleExp) pop();
        AKeepManyTupleExp node = new AKeepManyTupleExp(node1, node2, node3, node4, node5);
        return node;
    }

    Node new122()
    {
        TRPar node5 = (TRPar) pop();
        PIdentifiers node4 = (PIdentifiers) pop();
        TLPar node3 = (TLPar) pop();
        TRemove node2 = (TRemove) pop();
        PTupleExp node1 = (PTupleExp) pop();
        ARemoveManyTupleExp node = new ARemoveManyTupleExp(node1, node2, node3, node4, node5);
        return node;
    }

    Node new123()
    {
        PUnaryExp node1 = (PUnaryExp) pop();
        ADefaultTupleExp node = new ADefaultTupleExp(node1);
        return node;
    }

    Node new124()
    {
        PBaseExp node2 = (PBaseExp) pop();
        TNot node1 = (TNot) pop();
        ANotUnaryExp node = new ANotUnaryExp(node1, node2);
        return node;
    }

    Node new125()
    {
        PBaseExp node2 = (PBaseExp) pop();
        TMinus node1 = (TMinus) pop();
        ANegUnaryExp node = new ANegUnaryExp(node1, node2);
        return node;
    }

    Node new126()
    {
        PBaseExp node1 = (PBaseExp) pop();
        ADefaultUnaryExp node = new ADefaultUnaryExp(node1);
        return node;
    }

    Node new127()
    {
        PLvalue node1 = (PLvalue) pop();
        ALvalueBaseExp node = new ALvalueBaseExp(node1);
        return node;
    }

    Node new128()
    {
        TRPar node4 = (TRPar) pop();
        PExps node3 = null;
        TLPar node2 = (TLPar) pop();
        TIdentifier node1 = (TIdentifier) pop();
        ACallBaseExp node = new ACallBaseExp(node1, node2, node3, node4);
        return node;
    }

    Node new129()
    {
        TRPar node4 = (TRPar) pop();
        PExps node3 = (PExps) pop();
        TLPar node2 = (TLPar) pop();
        TIdentifier node1 = (TIdentifier) pop();
        ACallBaseExp node = new ACallBaseExp(node1, node2, node3, node4);
        return node;
    }

    Node new130()
    {
        TIntconst node1 = (TIntconst) pop();
        AIntBaseExp node = new AIntBaseExp(node1);
        return node;
    }

    Node new131()
    {
        TTrue node1 = (TTrue) pop();
        ATrueBaseExp node = new ATrueBaseExp(node1);
        return node;
    }

    Node new132()
    {
        TFalse node1 = (TFalse) pop();
        AFalseBaseExp node = new AFalseBaseExp(node1);
        return node;
    }

    Node new133()
    {
        TStringconst node1 = (TStringconst) pop();
        AStringBaseExp node = new AStringBaseExp(node1);
        return node;
    }

    Node new134()
    {
        TRBrace node4 = (TRBrace) pop();
        PFieldvalues node3 = null;
        TLBrace node2 = (TLBrace) pop();
        TTuple node1 = (TTuple) pop();
        ATupleBaseExp node = new ATupleBaseExp(node1, node2, node3, node4);
        return node;
    }

    Node new135()
    {
        TRBrace node4 = (TRBrace) pop();
        PFieldvalues node3 = (PFieldvalues) pop();
        TLBrace node2 = (TLBrace) pop();
        TTuple node1 = (TTuple) pop();
        ATupleBaseExp node = new ATupleBaseExp(node1, node2, node3, node4);
        return node;
    }

    Node new136()
    {
        TRPar node3 = (TRPar) pop();
        PExp node2 = (PExp) pop();
        TLPar node1 = (TLPar) pop();
        AParenBaseExp node = new AParenBaseExp(node1, node2, node3);
        return node;
    }

    Node new137()
    {
        PExp node1 = (PExp) pop();
        AOneExps node = new AOneExps(node1);
        return node;
    }

    Node new138()
    {
        PExp node3 = (PExp) pop();
        TComma node2 = (TComma) pop();
        PExps node1 = (PExps) pop();
        AManyExps node = new AManyExps(node1, node2, node3);
        return node;
    }

    Node new139()
    {
        TIdentifier node1 = (TIdentifier) pop();
        ASimpleLvalue node = new ASimpleLvalue(node1);
        return node;
    }

    Node new140()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TDot node2 = (TDot) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AQualifiedLvalue node = new AQualifiedLvalue(node1, node2, node3);
        return node;
    }

    Node new141()
    {
        PFieldvalue node1 = (PFieldvalue) pop();
        AOneFieldvalues node = new AOneFieldvalues(node1);
        return node;
    }

    Node new142()
    {
        PFieldvalue node3 = (PFieldvalue) pop();
        TComma node2 = (TComma) pop();
        PFieldvalues node1 = (PFieldvalues) pop();
        AManyFieldvalues node = new AManyFieldvalues(node1, node2, node3);
        return node;
    }

    Node new143()
    {
        PExp node3 = (PExp) pop();
        TAssign node2 = (TAssign) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AFieldvalue node = new AFieldvalue(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, },
			{{-1, ERROR, 1}, {26, SHIFT, 3}, },
			{{-1, ERROR, 2}, {66, ACCEPT, -1}, },
			{{-1, ERROR, 3}, {1, SHIFT, 4}, },
			{{-1, ERROR, 4}, {2, SHIFT, 7}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 6}, {1, SHIFT, 4}, {9, SHIFT, 8}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 7}, {58, SHIFT, 26}, },
			{{-1, ERROR, 8}, {58, SHIFT, 27}, },
			{{-1, ERROR, 9}, {58, SHIFT, 28}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 14}, {58, SHIFT, 29}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 19}, {58, SHIFT, 30}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 22}, {10, SHIFT, 9}, {27, SHIFT, 32}, },
			{{-1, ERROR, 23}, {9, SHIFT, 8}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 24}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 25}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 26}, {28, SHIFT, 44}, },
			{{-1, ERROR, 27}, {26, SHIFT, 45}, },
			{{-1, ERROR, 28}, {37, SHIFT, 46}, },
			{{-1, REDUCE, 54}, },
			{{-1, REDUCE, 47}, {37, SHIFT, 47}, },
			{{-1, ERROR, 31}, {29, SHIFT, 48}, {41, SHIFT, 49}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 35}, {10, SHIFT, 9}, {27, SHIFT, 50}, },
			{{-1, ERROR, 36}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 37}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 39}, {10, SHIFT, 9}, {27, SHIFT, 54}, },
			{{-1, ERROR, 40}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 41}, {58, SHIFT, 56}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 43}, {10, SHIFT, 9}, {27, SHIFT, 57}, },
			{{-1, ERROR, 44}, {3, SHIFT, 58}, },
			{{-1, ERROR, 45}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {27, SHIFT, 59}, },
			{{-1, ERROR, 46}, {38, SHIFT, 63}, },
			{{-1, ERROR, 47}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, {38, SHIFT, 64}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 49}, {58, SHIFT, 68}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 51}, {10, SHIFT, 9}, {27, SHIFT, 69}, },
			{{-1, ERROR, 52}, {10, SHIFT, 9}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, ERROR, 53}, {10, SHIFT, 9}, {27, SHIFT, 71}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 55}, {10, SHIFT, 9}, {27, SHIFT, 72}, },
			{{-1, ERROR, 56}, {37, SHIFT, 47}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 58}, {4, SHIFT, 73}, {30, SHIFT, 74}, {32, SHIFT, 75}, {35, SHIFT, 76}, {64, SHIFT, 77}, {65, SHIFT, 78}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 61}, {58, SHIFT, 81}, },
			{{-1, ERROR, 62}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {27, SHIFT, 82}, },
			{{-1, ERROR, 63}, {26, SHIFT, 84}, },
			{{-1, ERROR, 64}, {26, SHIFT, 84}, },
			{{-1, ERROR, 65}, {58, SHIFT, 87}, },
			{{-1, ERROR, 66}, {38, SHIFT, 88}, {41, SHIFT, 89}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 70}, {10, SHIFT, 9}, {27, SHIFT, 90}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 73}, {29, SHIFT, 91}, },
			{{-1, ERROR, 74}, {5, SHIFT, 92}, {6, SHIFT, 93}, {58, SHIFT, 94}, },
			{{-1, ERROR, 75}, {58, SHIFT, 95}, },
			{{-1, ERROR, 76}, {58, SHIFT, 96}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 80}, {4, SHIFT, 97}, {30, SHIFT, 74}, {32, SHIFT, 75}, {35, SHIFT, 76}, {64, SHIFT, 77}, {65, SHIFT, 78}, },
			{{-1, ERROR, 81}, {29, SHIFT, 99}, },
			{{-1, REDUCE, 42}, },
			{{-1, REDUCE, 43}, },
			{{-1, ERROR, 84}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 105}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {27, SHIFT, 108}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 59}, },
			{{-1, ERROR, 88}, {26, SHIFT, 84}, },
			{{-1, ERROR, 89}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 14}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 92}, {7, SHIFT, 134}, {8, SHIFT, 135}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 93}, {7, SHIFT, 134}, {8, SHIFT, 135}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 94}, {7, SHIFT, 134}, {8, SHIFT, 135}, {31, SHIFT, 144}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 95}, {31, SHIFT, 146}, },
			{{-1, ERROR, 96}, {36, SHIFT, 147}, },
			{{-1, ERROR, 97}, {29, SHIFT, 148}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 100}, {17, SHIFT, 149}, {58, SHIFT, 150}, },
			{{-1, ERROR, 101}, {17, SHIFT, 149}, {58, SHIFT, 150}, },
			{{-1, ERROR, 102}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {29, SHIFT, 154}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 103}, {37, SHIFT, 156}, },
			{{-1, ERROR, 104}, {37, SHIFT, 157}, },
			{{-1, ERROR, 105}, {26, SHIFT, 158}, {58, SHIFT, 29}, },
			{{-1, REDUCE, 131}, },
			{{-1, REDUCE, 132}, },
			{{-1, REDUCE, 85}, },
			{{-1, REDUCE, 61}, },
			{{-1, ERROR, 110}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 111}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 112}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 139}, {37, SHIFT, 163}, {57, SHIFT, 164}, },
			{{-1, REDUCE, 130}, },
			{{-1, REDUCE, 133}, },
			{{-1, ERROR, 116}, {58, SHIFT, 165}, },
			{{-1, REDUCE, 89}, },
			{{-1, REDUCE, 70}, },
			{{-1, ERROR, 119}, {29, SHIFT, 166}, },
			{{-1, REDUCE, 98}, {56, SHIFT, 167}, },
			{{-1, REDUCE, 100}, {55, SHIFT, 168}, },
			{{-1, REDUCE, 102}, },
			{{-1, REDUCE, 109}, {30, SHIFT, 169}, {31, SHIFT, 170}, {45, SHIFT, 171}, {46, SHIFT, 172}, {47, SHIFT, 173}, {48, SHIFT, 174}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 112}, {52, SHIFT, 177}, {53, SHIFT, 178}, {54, SHIFT, 179}, },
			{{-1, REDUCE, 116}, },
			{{-1, REDUCE, 118}, {42, SHIFT, 180}, {43, SHIFT, 181}, {44, SHIFT, 182}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 126}, },
			{{-1, REDUCE, 127}, {28, SHIFT, 183}, },
			{{-1, ERROR, 130}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {19, SHIFT, 10}, {20, SHIFT, 11}, {21, SHIFT, 12}, {22, SHIFT, 13}, {23, SHIFT, 105}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {27, SHIFT, 184}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 131}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {27, SHIFT, 186}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 58}, },
			{{-1, ERROR, 134}, {28, SHIFT, 188}, },
			{{-1, ERROR, 135}, {28, SHIFT, 189}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 33}, {28, SHIFT, 190}, },
			{{-1, ERROR, 142}, {7, SHIFT, 134}, {8, SHIFT, 135}, {31, SHIFT, 191}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 143}, {7, SHIFT, 134}, {8, SHIFT, 135}, {31, SHIFT, 193}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 145}, {7, SHIFT, 134}, {8, SHIFT, 135}, {31, SHIFT, 194}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, REDUCE, 26}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 149}, {58, SHIFT, 195}, },
			{{-1, REDUCE, 82}, },
			{{-1, ERROR, 151}, {18, SHIFT, 196}, {29, SHIFT, 197}, },
			{{-1, ERROR, 152}, {29, SHIFT, 199}, },
			{{-1, ERROR, 153}, {26, SHIFT, 158}, },
			{{-1, REDUCE, 65}, },
			{{-1, ERROR, 155}, {29, SHIFT, 200}, },
			{{-1, ERROR, 156}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 157}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 158}, {27, SHIFT, 203}, {58, SHIFT, 204}, },
			{{-1, ERROR, 159}, {38, SHIFT, 207}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 127}, },
			{{-1, REDUCE, 125}, },
			{{-1, ERROR, 163}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {38, SHIFT, 208}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 164}, {58, SHIFT, 211}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 71}, },
			{{-1, ERROR, 167}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 168}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 169}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 170}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 171}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 172}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 173}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 174}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 175}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 176}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 177}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 178}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 179}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 180}, {37, SHIFT, 225}, {58, SHIFT, 226}, },
			{{-1, ERROR, 181}, {37, SHIFT, 227}, {58, SHIFT, 228}, },
			{{-1, ERROR, 182}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 183}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 86}, },
			{{-1, ERROR, 185}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {27, SHIFT, 231}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 87}, },
			{{-1, REDUCE, 88}, },
			{{-1, ERROR, 188}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 189}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, ERROR, 190}, {58, SHIFT, 136}, {60, SHIFT, 137}, {61, SHIFT, 138}, {63, SHIFT, 139}, },
			{{-1, REDUCE, 30}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 193}, {30, SHIFT, 74}, {32, SHIFT, 235}, {35, SHIFT, 76}, {64, SHIFT, 77}, {65, SHIFT, 78}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 195}, {39, SHIFT, 237}, },
			{{-1, ERROR, 196}, {39, SHIFT, 238}, },
			{{-1, REDUCE, 62}, },
			{{-1, ERROR, 198}, {29, SHIFT, 239}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 66}, },
			{{-1, ERROR, 201}, {38, SHIFT, 240}, },
			{{-1, ERROR, 202}, {38, SHIFT, 241}, },
			{{-1, REDUCE, 134}, },
			{{-1, ERROR, 204}, {28, SHIFT, 242}, },
			{{-1, ERROR, 205}, {27, SHIFT, 243}, {41, SHIFT, 244}, },
			{{-1, REDUCE, 141}, },
			{{-1, REDUCE, 136}, },
			{{-1, REDUCE, 128}, },
			{{-1, REDUCE, 137}, },
			{{-1, ERROR, 210}, {38, SHIFT, 245}, {41, SHIFT, 246}, },
			{{-1, REDUCE, 140}, },
			{{-1, REDUCE, 99}, {55, SHIFT, 168}, },
			{{-1, REDUCE, 101}, },
			{{-1, REDUCE, 105}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 106}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 103}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 104}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 107}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 108}, {50, SHIFT, 175}, {51, SHIFT, 176}, },
			{{-1, REDUCE, 111}, {52, SHIFT, 177}, {53, SHIFT, 178}, {54, SHIFT, 179}, },
			{{-1, REDUCE, 110}, {52, SHIFT, 177}, {53, SHIFT, 178}, {54, SHIFT, 179}, },
			{{-1, REDUCE, 113}, },
			{{-1, REDUCE, 114}, },
			{{-1, REDUCE, 115}, },
			{{-1, ERROR, 225}, {58, SHIFT, 165}, },
			{{-1, REDUCE, 119}, },
			{{-1, ERROR, 227}, {58, SHIFT, 165}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 117}, },
			{{-1, REDUCE, 97}, {56, SHIFT, 167}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 235}, {6, SHIFT, 249}, {58, SHIFT, 95}, },
			{{-1, ERROR, 236}, {30, SHIFT, 74}, {32, SHIFT, 250}, {35, SHIFT, 76}, {64, SHIFT, 77}, {65, SHIFT, 78}, },
			{{-1, ERROR, 237}, {58, SHIFT, 251}, },
			{{-1, ERROR, 238}, {58, SHIFT, 254}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 240}, {11, SHIFT, 258}, {12, SHIFT, 259}, {13, SHIFT, 260}, {14, SHIFT, 261}, {16, SHIFT, 262}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 263}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 241}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 242}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 135}, },
			{{-1, ERROR, 244}, {58, SHIFT, 204}, },
			{{-1, REDUCE, 129}, },
			{{-1, ERROR, 246}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 247}, {38, SHIFT, 272}, {41, SHIFT, 49}, },
			{{-1, ERROR, 248}, {38, SHIFT, 273}, {41, SHIFT, 49}, },
			{{-1, ERROR, 249}, {31, SHIFT, 274}, },
			{{-1, ERROR, 250}, {6, SHIFT, 275}, {58, SHIFT, 95}, },
			{{-1, ERROR, 251}, {28, SHIFT, 276}, },
			{{-1, ERROR, 252}, {40, SHIFT, 277}, {41, SHIFT, 278}, },
			{{-1, REDUCE, 91}, },
			{{-1, REDUCE, 139}, {57, SHIFT, 164}, },
			{{-1, ERROR, 255}, {40, SHIFT, 279}, {41, SHIFT, 280}, },
			{{-1, REDUCE, 94}, },
			{{-1, ERROR, 257}, {28, SHIFT, 281}, },
			{{-1, ERROR, 258}, {17, SHIFT, 149}, {58, SHIFT, 150}, },
			{{-1, ERROR, 259}, {17, SHIFT, 149}, {58, SHIFT, 150}, },
			{{-1, ERROR, 260}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {29, SHIFT, 284}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 261}, {37, SHIFT, 286}, },
			{{-1, ERROR, 262}, {37, SHIFT, 287}, },
			{{-1, REDUCE, 61}, {15, REDUCE, 72}, },
			{{-1, REDUCE, 67}, },
			{{-1, ERROR, 265}, {15, SHIFT, 288}, },
			{{-1, REDUCE, 70}, {15, REDUCE, 80}, },
			{{-1, ERROR, 267}, {29, SHIFT, 289}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 143}, },
			{{-1, REDUCE, 142}, },
			{{-1, REDUCE, 138}, },
			{{-1, REDUCE, 121}, },
			{{-1, REDUCE, 122}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 275}, {31, SHIFT, 290}, },
			{{-1, ERROR, 276}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 83}, },
			{{-1, ERROR, 278}, {58, SHIFT, 251}, },
			{{-1, REDUCE, 84}, },
			{{-1, ERROR, 280}, {58, SHIFT, 254}, },
			{{-1, ERROR, 281}, {58, SHIFT, 294}, },
			{{-1, ERROR, 282}, {18, SHIFT, 196}, {29, SHIFT, 295}, },
			{{-1, ERROR, 283}, {29, SHIFT, 297}, },
			{{-1, REDUCE, 65}, {15, REDUCE, 76}, },
			{{-1, ERROR, 285}, {29, SHIFT, 298}, },
			{{-1, ERROR, 286}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 287}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 288}, {11, SHIFT, 100}, {12, SHIFT, 101}, {13, SHIFT, 102}, {14, SHIFT, 103}, {16, SHIFT, 104}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 109}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 71}, {15, REDUCE, 81}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 93}, },
			{{-1, REDUCE, 92}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 62}, {15, REDUCE, 73}, },
			{{-1, ERROR, 296}, {29, SHIFT, 302}, },
			{{-1, REDUCE, 64}, {15, REDUCE, 75}, },
			{{-1, REDUCE, 66}, {15, REDUCE, 77}, },
			{{-1, ERROR, 299}, {38, SHIFT, 303}, },
			{{-1, ERROR, 300}, {38, SHIFT, 304}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 63}, {15, REDUCE, 74}, },
			{{-1, ERROR, 303}, {11, SHIFT, 258}, {12, SHIFT, 259}, {13, SHIFT, 260}, {14, SHIFT, 261}, {16, SHIFT, 262}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 263}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 304}, {11, SHIFT, 258}, {12, SHIFT, 259}, {13, SHIFT, 260}, {14, SHIFT, 261}, {16, SHIFT, 262}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 263}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, ERROR, 305}, {15, SHIFT, 307}, },
			{{-1, REDUCE, 79}, },
			{{-1, ERROR, 307}, {11, SHIFT, 258}, {12, SHIFT, 259}, {13, SHIFT, 260}, {14, SHIFT, 261}, {16, SHIFT, 262}, {23, SHIFT, 153}, {24, SHIFT, 106}, {25, SHIFT, 107}, {26, SHIFT, 84}, {29, SHIFT, 263}, {37, SHIFT, 110}, {49, SHIFT, 111}, {50, SHIFT, 112}, {58, SHIFT, 113}, {59, SHIFT, 114}, {62, SHIFT, 115}, },
			{{-1, REDUCE, 78}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 2}, },
			{{-1, 5}, {6, 15}, },
			{{-1, 79}, {80, 98}, {236, 98}, },
			{{-1, 140}, {142, 192}, {143, 192}, {145, 192}, },
			{{-1, 141}, {188, 232}, {189, 233}, {190, 234}, },
			{{-1, 16}, {23, 34}, },
			{{-1, 60}, {62, 83}, },
			{{-1, 17}, {24, 38}, {36, 38}, {130, 38}, },
			{{-1, 31}, {225, 247}, {227, 248}, },
			{{-1, 18}, {45, 61}, {62, 61}, },
			{{-1, 19}, {25, 41}, {37, 41}, {40, 41}, {47, 65}, {52, 41}, {84, 116}, {89, 65}, {130, 116}, },
			{{-1, 20}, {25, 42}, {37, 42}, {40, 42}, {52, 42}, },
			{{-1, 66}, },
			{{-1, 67}, {89, 133}, },
			{{-1, 21}, {22, 33}, {35, 33}, {39, 33}, {43, 33}, {51, 33}, {53, 33}, {55, 33}, {70, 33}, },
			{{-1, 117}, {131, 187}, {185, 187}, {240, 264}, {241, 268}, {288, 301}, {303, 264}, {304, 268}, {307, 301}, },
			{{-1, 265}, {303, 305}, {304, 306}, {307, 308}, },
			{{-1, 151}, {101, 152}, {258, 282}, {259, 283}, },
			{{-1, 198}, {282, 296}, },
			{{-1, 118}, {63, 85}, {64, 86}, {88, 132}, {240, 266}, {303, 266}, {304, 266}, {307, 266}, },
			{{-1, 252}, },
			{{-1, 253}, {278, 292}, },
			{{-1, 255}, },
			{{-1, 256}, {280, 293}, },
			{{-1, 119}, {102, 155}, {110, 159}, {156, 201}, {157, 202}, {163, 209}, {240, 267}, {242, 269}, {246, 271}, {260, 285}, {276, 291}, {286, 299}, {287, 300}, {303, 267}, {304, 267}, {307, 267}, },
			{{-1, 120}, {183, 230}, },
			{{-1, 121}, {167, 212}, },
			{{-1, 122}, {168, 213}, },
			{{-1, 123}, {169, 214}, {170, 215}, {171, 216}, {172, 217}, {173, 218}, {174, 219}, },
			{{-1, 124}, {175, 220}, {176, 221}, },
			{{-1, 125}, {177, 222}, {178, 223}, {179, 224}, {182, 229}, },
			{{-1, 126}, },
			{{-1, 127}, },
			{{-1, 128}, {111, 160}, {112, 162}, },
			{{-1, 210}, },
			{{-1, 129}, {111, 161}, {112, 161}, {167, 161}, {168, 161}, {169, 161}, {170, 161}, {171, 161}, {172, 161}, {173, 161}, {174, 161}, {175, 161}, {176, 161}, {177, 161}, {178, 161}, {179, 161}, {182, 161}, {183, 161}, {238, 257}, {280, 257}, },
			{{-1, 205}, },
			{{-1, 206}, {244, 270}, },
			{{-1, 6}, },
			{{-1, 22}, {23, 35}, {24, 39}, {25, 43}, {36, 51}, {37, 53}, {40, 55}, {52, 70}, },
			{{-1, 23}, },
			{{-1, 24}, {23, 36}, {84, 130}, },
			{{-1, 25}, {23, 37}, {24, 40}, {36, 52}, },
			{{-1, 80}, {193, 236}, },
			{{-1, 142}, {93, 143}, {94, 145}, },
			{{-1, 62}, },
			{{-1, 131}, {130, 185}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'service'",
			"expecting: '{'",
			"expecting: EOF",
			"expecting: 'const'",
			"expecting: 'html'",
			"expecting: 'const', 'schema', 'session', 'int', 'bool', 'string', 'void', 'tuple'",
			"expecting: identifier",
			"expecting: 'schema', 'session', 'int', 'bool', 'string', 'void', 'tuple'",
			"expecting: 'session', 'show', 'exit', 'return', 'if', 'while', 'int', 'bool', 'string', 'void', 'tuple', 'true', 'false', '{', '}', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'session', 'int', 'bool', 'string', 'void', 'tuple'",
			"expecting: 'session', '}'",
			"expecting: '='",
			"expecting: '('",
			"expecting: ';', '(', ','",
			"expecting: ';', ','",
			"expecting: '<html>'",
			"expecting: 'int', 'bool', 'string', 'void', '}'",
			"expecting: ')'",
			"expecting: 'int', 'bool', 'string', 'void', 'tuple', ')'",
			"expecting: '</html>', '<', '</', '<[', meta, whatever",
			"expecting: ')', ','",
			"expecting: ';', ')', ','",
			"expecting: ';'",
			"expecting: 'input', 'select', identifier",
			"expecting: 'show', 'exit', 'return', 'if', 'while', 'int', 'bool', 'string', 'void', 'tuple', 'true', 'false', '{', '}', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'int', 'bool', 'string', 'void', 'tuple'",
			"expecting: 'name', 'type', identifier, tagintconst, percentconst, tagstringconst",
			"expecting: 'name', 'type', '>', identifier, tagintconst, percentconst, tagstringconst",
			"expecting: '>'",
			"expecting: ']>'",
			"expecting: 'plug', identifier",
			"expecting: 'tuple', 'true', 'false', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: '{', identifier",
			"expecting: '}', ';', '<', '>', ')', ']', ',', '\+', '\-', '<<', '==', '!=', '<=', '>=', '-', '+', '*', '/', '%', '&&', '||'",
			"expecting: 'session', 'show', 'exit', 'return', 'if', 'else', 'while', 'int', 'bool', 'string', 'void', 'tuple', 'true', 'false', '{', '}', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'show', 'exit', 'return', 'if', 'while', 'tuple', 'true', 'false', '{', '}', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'tuple', 'true', 'false', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'tuple', 'true', 'false', '(', identifier, intconst, stringconst",
			"expecting: '}', '=', ';', '<', '>', '(', ')', ']', ',', '\+', '\-', '<<', '==', '!=', '<=', '>=', '-', '+', '*', '/', '%', '&&', '||', '.'",
			"expecting: '}', ';', ')', ']', ',', '||'",
			"expecting: '}', ';', ')', ']', ',', '&&', '||'",
			"expecting: '}', ';', '<', '>', ')', ']', ',', '==', '!=', '<=', '>=', '-', '+', '&&', '||'",
			"expecting: '}', ';', '<', '>', ')', ']', ',', '==', '!=', '<=', '>=', '-', '+', '*', '/', '%', '&&', '||'",
			"expecting: '}', '=', ';', '<', '>', ')', ']', ',', '\+', '\-', '<<', '==', '!=', '<=', '>=', '-', '+', '*', '/', '%', '&&', '||'",
			"expecting: 'name', 'type', '=', '>', identifier, tagintconst, percentconst, tagstringconst",
			"expecting: 'receive', ';'",
			"expecting: '}', identifier",
			"expecting: 'tuple', 'true', 'false', '(', ')', '!', '-', identifier, intconst, stringconst",
			"expecting: '(', identifier",
			"expecting: identifier, tagintconst, percentconst, tagstringconst",
			"expecting: '<', '</', '<[', meta, whatever",
			"expecting: '['",
			"expecting: '}', ','",
			"expecting: '}', ';', ')', ']', ',', '-', '+', '&&', '||'",
			"expecting: 'select', identifier",
			"expecting: 'show', 'exit', 'return', 'if', 'while', 'tuple', 'true', 'false', '{', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: ']', ','",
			"expecting: '=', '.'",
			"expecting: 'show', 'exit', 'return', 'if', 'else', 'while', 'tuple', 'true', 'false', '{', '}', ';', '(', '!', '-', identifier, intconst, stringconst",
			"expecting: 'else'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 4, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 5, 7, 8, 6, 6, 9, 10, 10, 7, 9, 9, 11, 1, 12, 6, 13, 14, 2, 10, 7, 10, 9, 9, 8, 10, 9, 6, 9, 10, 15, 16, 17, 18, 8, 6, 2, 10, 9, 10, 2, 10, 12, 2, 19, 7, 16, 6, 16, 1, 1, 6, 20, 20, 21, 2, 10, 2, 2, 22, 23, 6, 6, 19, 19, 19, 19, 22, 7, 16, 24, 10, 9, 20, 1, 25, 2, 5, 26, 26, 27, 28, 29, 22, 19, 16, 30, 30, 31, 12, 12, 32, 33, 33, 34, 35, 36, 37, 37, 38, 33, 33, 6, 35, 35, 22, 39, 40, 40, 41, 42, 42, 33, 33, 33, 43, 24, 35, 9, 20, 11, 11, 44, 44, 44, 44, 27, 44, 27, 27, 19, 27, 19, 19, 5, 6, 45, 45, 22, 1, 35, 22, 36, 36, 46, 17, 33, 33, 33, 47, 6, 21, 35, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 48, 48, 36, 36, 34, 35, 34, 35, 49, 49, 49, 19, 27, 50, 19, 51, 51, 35, 22, 35, 35, 17, 17, 33, 11, 52, 52, 33, 33, 20, 20, 43, 40, 40, 53, 53, 53, 53, 53, 53, 42, 42, 42, 42, 42, 6, 33, 6, 33, 42, 39, 34, 27, 27, 27, 54, 50, 6, 6, 35, 55, 55, 36, 33, 6, 33, 36, 20, 20, 28, 54, 11, 56, 56, 57, 56, 56, 11, 30, 30, 31, 12, 12, 58, 35, 59, 58, 22, 35, 52, 52, 20, 33, 33, 19, 28, 36, 45, 6, 22, 6, 6, 45, 22, 58, 22, 36, 36, 55, 58, 19, 56, 56, 56, 56, 58, 22, 58, 58, 17, 17, 35, 58, 55, 55, 59, 59, 55, 59, 
        };*/
}
