/*
    The Constant for Type and Kind
 */
package wig.symbol;

public class Const
{
    public static Kind html     = new Kind("html");
    public static Kind hole     = new Kind("hole");
    public static Kind variable = new Kind("variable");
    public static Kind field    = new Kind("field");
    public static Kind schema   = new Kind("schema");
    public static Kind function = new Kind("function");
    public static Kind argument = new Kind("argument");
    public static Kind session  = new Kind("session");

    /*
     * Kind name = new Kind("name");
     * In our implementation, the name attribute in a tag
     * will not be an identifier. 
     * Instead, if the receiving form variable did not 
     * exist in the previous form, it will become an
     * empty string. 
     * This already works that way in our output language.
     * PHP.
     */

    public static Type tInt      = new Type("int");
    public static Type tBool     = new Type("bool");
    public static Type tVoid     = new Type("void");
    public static Type tString   = new Type("string");
    public static Type tTuple    = new Type("tuple");
}
