/*
    Symbol Object store the 
        id (String representation of the Node)
        node (reference to the node)
        Kind
        Type
 */
package wig.symbol;

import wig.node.*;

/* This is an element inside symboltable */
public class Symbol
{
    private String id;
    private Node node;
    private Kind kind;
    private Type type; /*schema identifier, int, boolean, void */

    //constructor
    public Symbol(String i, Kind k , Node n)
    {
        setIdentifier(i);
        setNode(n);
        setKind(k);
        type = null; /*no type necessary*/
    }

    public Symbol(String i, Kind k , Node n, Type t)
    {
        setIdentifier(i);
        setNode(n);
        setKind(k);
        setType(t);
    }

    public String getIdentifier()
    {
        return id;
    }
    public Node getNode()
    {
        return node;
    }
    public Kind getKind()
    {
        return kind;
    }
    public Type getType()
    {
        return type;
    }

    public void setIdentifier(String i)
    {
        id = i;
    }
    public void setNode(Node n)
    {
        node = n;
    }
    public void setKind(Kind k)
    {
        kind = k;
    }
    public void setType(Type t)
    {
        type = t;
    }

    public String toString()
    {
        String str;
        str = "("+getIdentifier()+",";
        str += getKind().toString()+",";
        if(getType()==null)
        {
            str += ")";
        }
        else
        {
            str += getType().toString()+")";
        }
        return str;
    }

}
